clear all
clc
fprintf('steg 1')
% % % STEG 1
%%%% inndata (Avgjr vektor for de ytre kreftene R, vanligvis fra FEM
%%%% analyse, og mengde av armering fra en initial dimensjonering)
Nx=3020;Ny=0;Nxy=0;Mx=-1017;My=0;Mxy=0; %Nx= normalkraft i x-retning, Ny= normalkraft i y-retning,
%Nxy= skjrkraft i planet, Mx= moment om y-aksen, My= moment om x-aksen,
%Mxy=torsjonsmomen)
R=[Nx Ny Nxy Mx*10^3 My*10^3 Mxy*10^3]'; % ytre lastvektor
n=100; % antall lameller i betong 
m=2;   % antall lameller i armering 
h=400; % tverrsnittshyde [mm]
c1=40; %  avstang fra nedre rand til tyndgepunktet i underkantarmering [mm]
c2=40; %  avstang fra vre rand til tyndgepunktet i overkantarmering [mm]
detah=h/n;% Hver tykkelse for hvert betonglamell
Maxdiffout=[];
if c1==0 && c2==0
    m=0;
end

iter = -1;

Asx=[4910/1000 4910/1000 0/1000 0/1000]; % armeringsareal i x-retning
Asy=[0/1000 0/1000 0/1000 0/1000]; % armeringsareal i y-retning
z=zeros(1,n);
Esx=2*10^5*ones(1,m);% elastisk modul for B500NC
Esy=2*10^5*ones(1,m);% elastisk modul for B500NC

for i=1:n
    z(i)=((n+1)/2-i)*detah;% avstand fra middel plan til midt i hver tykkelse
end


fck=30; % betongens karakteristiske sylingdertrykkfasthet etter 28 dgn 
fcm=fck+8;% middelverdi av betongens sylindertrykkfasthet
if fck<=50
    ecu1=3.5/1000; % tyningsgrense for trykk i betong ut fra tabel 3.1 i EC 2
    ec2=2/1000; % trykktyning i betong ut fra tabel 3.1 i EC 2
    ecu2=3.5/1000; % tyningsgrense for trykk i betong ut fra tabel 3.1 i EC 2
    n_1=2.0; % er eksponent i tabell 3.1 I EC 2
    ec3=1.75/1000;% trykktyning i betong ut fra tabel 3.1 i EC 2
    ecu3=3.5/1000;% tyningsgrense for trykk i betong ut fra tabel 3.1 i EC 2
else
    ecu1=(2.8+27*((98-fcm)/100)^4)/1000;
    ec2=(2+0.085*(fck-50)^0.53)/1000;
    ecu2=(2.6+35*((90-fck)/100)^4)/1000;
    n_1=1.4+23.4*((90-fck)/100)^4;
    ec3=(1.75+0.55*((fck-50)/40))/1000;
    ecu3=(2.6+3.5*((90-fck)/100)^4)/1000;
end
fck



Ecm=22*(fcm/10)^0.3*1000;% sekantmodul, elastisitetsmodulfor betong ut fra tabel 3.1 i EC 2
Ecm

v=0;
for i=1:n
    C0(:,:,i)=Ecm/(1-v^2)*[1 v 0;v 1 0;0 0 (1-v)/2];% isotropisk liner elastisk materialmatrikser for betong
end
C0



for num=1:10000 %%%%%%%%%%%%%%%%%%%%%%%%%iterasjon
    % CO1=C0{1}
    
    iter = iter +1;
    % % % % % % % % % % % % % % % STEG 2
    % % % %	BEREGN INITIELL STIVHETSMATRISE FOR LINER ELASTISK, ISOTROP
    % BETONG OG LINER ELSTISK
    fprintf('steg 2')
    
    for i=1:n
        A(:,:,i)=[1 0 0 -z(i) 0 0;0 1 0 0 -z(i) 0 ;0 0 1 0 0 -z(i);];% transformasjon A for betong
    end
    if n~=0
        A
    end
    Kc0=zeros(6,6);
    for i=1:n
        Kc0=Kc0+detah*A(:,:,i)'*C0(:,:,i)*A(:,:,i); % stivhetSmatrikse for betong
    end
    

   for  j=1:m
        if  m==0 
            zj(j)=0;
        elseif mod(m,2)==1
            zj(j)=h/2-c1; % avstand fra hver lamell i armering til skallmiddelflaten i x-retning
        elseif mod(m,2)==0
            zj(j)=h/2-c2; % avstand fra hver lamell i armering til skallmiddelflaten i y-retning
        end
        if mod(j,2)==1 % kontroll om positive og negative tegn
            zj(j)=-zj(j);
        end
   end

    
    for j=1:m
        if Asx==0
            Csx(:,:,j)=[0 0 0; 0 0 0 ;0 0 0;];
            Csy(:,:,j)=[0 0 0; 0 Esy(j) 0 ;0 0 0;];
        elseif Asy==0
            Csx(:,:,j)=[Esx(j) 0 0; 0 0 0 ;0 0 0;];
            Csy(:,:,j)=[0 0 0; 0 0 0 ;0 0 0;];
        else
            Csx(:,:,j)=[Esx(j) 0 0; 0 0 0 ;0 0 0;];% sekantmoduler for armering
            Csy(:,:,j)=[0 0 0; 0 Esy(j) 0 ;0 0 0;];% sekantmoduler for armering
        end
    end
    if m~=0
        Csx
        Csy
    end
    
    Ks0=zeros(6,6);
    for j=1:m
        Ks0=Ks0+(Asx(j)*[Csx(:,:,j)  -zj(j)*Csx(:,:,j) ;-zj(j)*Csx(:,:,j) zj(j)^2*Csx(:,:,j)]...
            +Asy(j)*[Csy(:,:,j)  -zj(j)*Csy(:,:,j) ;-zj(j)*Csy(:,:,j) zj(j)^2*Csy(:,:,j)]); % stivhetsmatrikse for liner elastisk armering
    end
    
    % BEREGN K0
    Kc0
    Ks0
    
    K0=Kc0+Ks0; % total stivhetsmatrikse
    K0
    
    
    % % % % % % % % % STEG 3
    %%%% TYNINGER OG KRUMNINGER I SKALLMIDDELFLATEN
    fprintf('steg 3')
    et0=inv(K0)*R;
    et0
    
    
    % % % % % % % % % steg 4
    %%%% TYNINGSILSTAND I HVER LAMELL (BDE BETONG- OG ARMERINGSLAMELLER)
    %%%% REFERERT TIL GLOBALT XY-SYSTEM
    fprintf('steg 4')
    for i=1:n
        e0(:,:,i)=A(:,:,i)*et0; %tyning for betong i hver lamell
    end
    e0
    
    for j=1:m
        Aj(:,:,j)=[1 0 0 -zj(j) 0 0;0 1 0 0 -zj(j) 0 ;0 0 0 0 0 0;];% transform Aj for armering
    end
    if m~=0
        Aj
    end
    for j=1:m
        if m==0
            ej0(:,:,j)=zeros(3,1);
        else
                ej0(:,:,j)=Aj(:,:,j)*et0;%tyning for armering i hver lamell
                ej0(3,:,j)=0;
            end
            
        end
        if m~=0
            ej0
        end
    
    
    % % % % % % % % % STEG 5
    %%%% HOVEDTYNINGER OG -RETNING I BETONGLAMELLENE
    fprintf('steg 5')
    for i=1:n
        ex(i)=e0(1,:,i);% tyning i global x-retning
        ey(i)=e0(2,:,i);% tyning i global y-retning
        rxy(i)=e0(3,:,i);% skjrtyning i global
        theta(i)=(0.5*atan(rxy(i)/(ex(i)-ey(i))));% theta(i) er transform matriks fra global akse til lokal hovedretning
    end
    theta
    for i=1:n
        
        ep0(:,:,i)=Tfun(theta(i))*e0(:,:,i);%lokal hovedtyning
    
        T=Tfun(theta(i))
    end
    T
    ep0
    
    
    % % % % % % % % STEG 6 
    %%%% HOVEDSPENNINGER I LAMELLER ( HER BLIR IKKELINERE
    %%%% MATERIALEGENSKAPER TATT VARE P)
    fprintf('steg 6')
    acc=0.85;
    if acc==0.85 % er en koeffisient som tar hensyn til virkninger av langtislast p trykkfasthet samt ugunstige virkninger som er en flge av mten lasten pfres.
        gc=1.5; % materialfaktoren for betong
    end
    fcd=acc*(fck/gc); % dimensjonerende betongtrykkfasthet fra standard i EC2
    

    for i = 1:n
        if ep0(1,:,i) >=0 && ep0(1,:,i) <= ec2
             sigma_p0(1,:,i)=fcd*(1-(1- (ep0(1,:,i)/ec2)).^n_1); % ut fra 3.17 i EC 2
        elseif ep0(1,:,i) >= ec2
            sigma_p0(1,:,i)=fcd;
        elseif ep0(1,:,i) <0
            sigma_p0(1,:,i)=0;
        else
            sigma_p0(1,:,i)=0;
        end 
      
           if ep0(2,:,i) >=0 && ep0(2,:,i) <= ec2
             sigma_p0(2,:,i)=fcd*(1-(1- (ep0(2,:,i)/ec2)).^n_1); % ut fra 3.17 i EC 2
        elseif ep0(2,:,i) >= ec2
            sigma_p0(1,:,i)=fcd;
        elseif ep0(2,:,i) <0
            sigma_p0(2,:,i)=0;
        else
            sigma_p0(2,:,i)=0;
           end 
        
       sigma_p0(3,:,i)=0 ;
    end
    sigma_p0
            
    
    % % % % % % STEG 7
    %%%% TRANSFORMASJON AV HOVEDSPENNINGENE FOR HVER BETONGLAMELL TIL
    %%%% GLOBALT XY SYSTEM
    
    fprintf('steg 7')
    for i=1:n
        simga_c0(:,:,i)=Tfun(theta(i))'*sigma_p0(:,:,i);
    end
    simga_c0
    
    
    % % % % % % STEG 8
    %%%% ARMERINGSSPENNINGER FOR HVER ARMERINGSLAMELL
    fprintf('steg 8')
    E=2*10^5
    fyk=500; % armeringens karakteristisk flytegrense
    gs=1.15; % sikkerhetsfaktor
    fyd=fyk/gs; % armeringens dimensjonerende flytegrense
    for j=1:m
        esx=ej0(1,:,j);
        esy=ej0(2,:,j);
        rsxy=ej0(3,:,j);
        
        if abs(esx)<=fyd/E
            sigma_s0(1,:,j)= E* ej0(1,:,j); % spenniger fo armering
        else
            sigma_s0(1,:,j)=fyd.*sign(ej0(1,:,j));
        end
        
        if abs(esy)<= fyd/E
            sigma_s0(2,:,j)= E* ej0(2,:,j);
        else
            sigma_s0(2,:,j)=fyd.*sign(ej0(2,:,j));
        end
        sigma_s0(3,:,j)=0;
    end
    if m~=0
        sigma_s0
    end
    
    
    % % %% % % % STEG 9
    %%%% BEREGN INDRE KRAFTVEKTOR SOM SUM AV BETONG- OG ARMERINGSBIDREG
    fprintf('steg 9')
    sum1=zeros(6,1);
    for i=1:n
        sum1=sum1+detah*[simga_c0(:,:,i);-z(i)*simga_c0(:,:,i);];% sum av indre krefter for betong
    end

    sum2=zeros(6,1);
    for j=1:m
        simga_sx0= sigma_s0(1,:,j);
        simga_sy0= sigma_s0(2,:,j);
        sum2=sum2+[Asx(j)*simga_sx0;Asy(j)*simga_sy0;0;-zj(j)*Asx(j)*simga_sx0;-zj(j)*Asy(j)*simga_sy0;0;];
    end
    S0=sum1+sum2;% sum av indre krefter for betong  og armering
    S0
    
    
    
    % % % % % % % % STEG 10
    %%%%  DEFINISJON AV MAXDIFF
    tempdiff=abs((R-S0)./R);
    for l=1:length(tempdiff)
        if tempdiff(l)>=0 && tempdiff(l)<10000
            tempdiff(l)=tempdiff(l);
        else
            tempdiff(l)=0;
        end
    end
    Maxdiff=max(tempdiff);
    
    % % % % % % % % STEG 11
    %%%% SJEKK AV KONVERGENS
    beta=0.01; % iterasjon vil stoppe nr avvik er under en aksepetabel verdi (beta)
    if Maxdiff<beta
        fprintf('out');
        break;
    else
        Maxdiff
        Maxdiffout=[Maxdiffout Maxdiff];
    end
    
    % % % % % STEG 12
    %%%% FINN NYE SEKANTMODULER FOR BETONG- OG ARMERINGSLAMELLER 
    fprintf('steg 12')
    for j=1:m
        Esj(:,:,j)= sigma_s0(:,:,j)./ej0(:,:,j);
        Esj(3,:,j)=0;
        Esx(j)=Esj(1,:,j);
        Esy(j)=Esj(2,:,j);
        if Esj(1,:,j)>=0 && Esj(1,:,j)<1000000
            Esx(j)=Esj(1,:,j);
        else
            Esx(j)=0;
        end
        if Esj(2,:,j)>=0 && Esj(2,:,j)<1000000
            Esy(j)=Esj(2,:,j);
        else
            Esy(j)=0;
        end
    end
    Esx % nye sekantmoduler for armeringlameller i x-retning
    Esy % nye sekantmoduler for armeringlameller i y-retning
    
    for i=1:n
        if sigma_p0(1,:,i)>0.1
            E11(i)=sigma_p0(1,:,i)/ep0(1,:,i);
        elseif ep0(1,:,i)<= 0
            E11(i)=0.1;
        elseif 0<=sigma_p0(1,:,i) && sigma_p0(1,:,i)<=0.1
            E11(i)=Ecm;
        else
            E11(i)=0;
        end
        
        if sigma_p0(2,:,i)>0.1
            E22(i)=sigma_p0(2,:,i)/ep0(2,:,i);
        elseif ep0(2,:,i)<= 0
            E22(i)=0.1;
        elseif 0<=sigma_p0(2,:,i) && sigma_p0(2,:,i)<=0.1
            E22(i)=Ecm;
        else
            E22(i)=0;
        end
        
        E12(i)=(E11(i)+E22(i))/2;
    end
    if n~=0
        E11 % nye sekantmoduler for alle betongllameller
        E22 % nye sekantmoduler for alle betongllameller
        E12 % nye sekantmoduler for alle betongllameller
    end
    
    % % % % % % % % STEG 13
    %%%% BERGEN LOKALE MATERIALMATRIKSER
    fprintf('steg 13')
    for i=1:n
        Cp1(:,:,i)=(1/(1-v^2))*[E11(i) v*E12(i) 0;v*E12(i) E22(i) 0; 0 0 ((1-v)*E12(i))/2;];
    end
    if n~=0
        Cp1
    end
    
    % % % % % % STEG 14 
    %%%% TRANSFORMASJON AV LOKALE MATERIALMTRIKSER TIL GLOBALT XY-RETNING
    fprintf('steg 14')
    for i=1:n
        C0(:,:,i)=Tfun(theta(i))'* Cp1(:,:,i)*Tfun(theta(i));
        
    end
    if n~=0
        C0
    end
end

Maxdiffout

